//
//  MYVersionDictionary.h
//  Ottoman
//
//  Created by Jens Alfke on 9/21/09.
//  Copyright 2009 Jens Alfke. All rights reserved.
//

#import <Foundation/NSDictionary.h>

#ifdef __cplusplus
namespace Mooseyard {
    class OverlayDictionary;
    class VersionDictionary;
}
#endif


/** A persistent NSDictionary embedded in a memory-mapped file, 
    representing one complete version of a MYOttoman dictionary. */
@interface MYVersionDictionary : NSDictionary
{
#ifdef __cplusplus
    const Mooseyard::VersionDictionary *_dict;
#else
    void *_dict;
#endif
}

/** The generation number. The first version in a new file is zero. */
@property (readonly) int generation;

/** The time at which this version was written to the file. */
@property (readonly) NSDate *dateCreated;

/** The previous version, before this one was saved. */
@property (readonly) MYVersionDictionary *previousVersion;

/** Is this the latest version in the file? */
@property (readonly) BOOL isLatestVersion;

@end



@interface MYCurrentVersionDictionary : NSMutableDictionary
{
#ifdef __cplusplus
    Mooseyard::OverlayDictionary *_dict;
#else
    void *_dict;
#endif
}

@end
